import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.CullFace;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.shape.VertexFormat;

/**
 * IuWFNg[_[
 * <pre>
 * 3DIuWFNǧɂȂf[^ǂݍ݁Aێ܂B
 * ێ́ANXL[ɕێAHashMap̌`œɕێ܂B
 * create\bhĂ΂ꂽ^C~OŎۂ3Df[^ƂĐ܂B
 * gpʒጸƃXs[hAbvړIłB
 *
 * p`ɑΉB
 * Ap180x𒴂Ă͂܂B
 * p180x𒴂ꍇA\Ȃ܂B
 * </pre>
 */
public class ObjReader {

	/** _~[eNX` */
	private static final float[]				TEXCOORDS_DUMMY		= {
		0, 0
	};

	/** IuWFNgiftHgj */
	public static final String					OBJECT_NAME_DEFAULT	= "";

	/** AvP[V */
	protected static Application				application			= null;

	/** _ꗗiXvCg}bvj */
	private static HashMap<String, float[]>		mapPoints			= null;

	/** eNX`WꗗiXvCg}bvj */
	private static HashMap<String, float[]>		mapTexs				= null;

	/** _@ꗗiXvCg}bvj */
	private static HashMap<String, float[]>		mapNormals			= null;

	/** IuWFNgꗗiXvCg}bvj */
	private static HashMap<String, ArrayList<Object[]>>	mapObjects			= null;

	/**
	 * fobOx
	 * <pre>
	 * ʏ0ɂĂB
	 * PŊTvxAQARŏڍ׃x܂ŏo͂܂B
	 * </pre>
	 */
	private static int							lvlDebug			= 0;

	/**
	 * static 
	 * <pre>
	 * obj^mtlt@C̏ɕێ邽߂̏s܂B
	 * </pre>
	 */
	static {

		/** _ꗗiXvCg}bvj */
		mapPoints = new HashMap<String, float[]>();

		/** eNX`WꗗiXvCg}bvj */
		mapTexs = new HashMap<String, float[]>();

		/** _@ꗗiXvCg}bvj */
		mapNormals = new HashMap<String, float[]>();

		/** IuWFNgꗗiXvCg}bvj */
		mapObjects = new HashMap<String, ArrayList<Object[]>>();

	} // end static

	/**
	 * AvP[Vݒ
	 * <pre>
	 * t@CpX擾邽߂ɁAAvP[VNXݒ肵܂B
	 * init\bhĂяoOɁAݒsĂB
	 * </pre>
	 * @param application AvP[V
	 */
	public static void setApplication(Application application){
		ObjReader.application = application;
	}

	/**
	 * 
	 * <pre>
	 * sB
	 * t@Cw肵A3DIuWFNǧɂȂf[^ێ܂B
	 * ێ́ANXL[ɕێAHashMap̌`œɕێ܂B
	 * create\bhĂ΂ꂽ^C~OŎۂ3Df[^ƂĐ܂B
	 * {Iɂ́A\bh𗘗pĂB
	 * </pre>
	 * @param classSprite o^NXBNXɓǂݍ񂾃IuWFNgzu܂B
	 * @param strFilePath t@CpX
	 */
	public static void init(Class<?> classSprite, String strFilePath) throws Exception {

		// XvCgo^L[𐶐
		String strClassSprite = classSprite.getName();

		// ʃ\bhĂяo
		init(strClassSprite, strFilePath);

	} // end init

	/**
	 * 
	 * <pre>
	 * sB
	 * t@Cw肵A3DIuWFNǧɂȂf[^ێ܂B
	 * ێ́AStringL[ɕێAHashMap̌`œɕێ܂B
	 * create\bhĂ΂ꂽ^C~OŎۂ3Df[^ƂĐ܂B
	 * </pre>
	 * @param strSpriteKey XvCgo^L[Bǂݍ񂾃IuWFNg𓖃L[ŕێ܂B
	 * @param strFilePath t@CpX
	 */
	public static void init(String strSpriteKey, String strFilePath) throws Exception {

		// ftHgpX
		String				strDefaultPath	= null;

		// InputStream
		InputStream			is				= null;

		// InputStreamReader
		InputStreamReader	isr				= null;

		// LineNumberReader
		LineNumberReader	lnr				= null;

		// siG[\pj
		int row = 0;

		try{

			// fobOo
			outputDebugInfo(1, "START ObjReader.init. strFilePath:" + strFilePath);

			// t@CpX̃ftHgpXێ
			int indexDefaultPath = strFilePath.lastIndexOf("/");
			if(indexDefaultPath == -1){
				strDefaultPath = "";
			}else{
				strDefaultPath = strFilePath.substring(0, indexDefaultPath + 1);
			}

			// InputStream𐶐
			is = ObjReader.application.getClass().getResourceAsStream(strFilePath);

			// t@CȂꍇA
			if(is == null){
				// G[X[
				throw new IllegalStateException("File Not Found. filePath = " + strFilePath);
			}

			// InputStreamReader𐶐
			isr = new InputStreamReader(is);

			// LineNumberReader𐶐
			lnr = new LineNumberReader(isr);

			// _Wꗗ𐶐
			ArrayList<Float> pointLst = new ArrayList<Float>();
			// eNX`ꗗ𐶐
			ArrayList<Float> texLst = new ArrayList<Float>();
			// @ꗗ𐶐
			ArrayList<Float> normalLst = new ArrayList<Float>();

			// IuWFNgꗗ𐶐
			ArrayList<Object[]> objectsLst = new ArrayList<Object[]>();

			// ʗvfꗗ𐶐
			ArrayList<Integer> faceLst = new ArrayList<Integer>();
			// }eAꗗ𐶐
			ArrayList<Object[]> materialLst = new ArrayList<Object[]>();

			// ʗvf
			int countFaces = 2;

			// IuWFNgɃftHglݒ
			String strObjectName = OBJECT_NAME_DEFAULT;

			// }eA
			String strMaterialName = null;

			// }eA}bv
			HashMap<String, PhongMaterial> mapMaterial = null;

			// sA[v
			while(true){

				// s{P
				row++;

				// Ps擾
				String strLine = lnr.readLine();

				// s񂪎擾łȂꍇA
				if(strLine == null){
					// [v𔲂
					break;
				}

				// g[N𐶐
				StringTokenizer stLine = new StringTokenizer(strLine, " ");

				// ꗗ
				ArrayList<String> strLst = new ArrayList<String>(5);

				// g[NA[v
				while(true){

					// g[NȂꍇA
					if(!stLine.hasMoreTokens()){
						// [v𔲂
						break;
					}

					// g[N𕶎ꗗɊi[
					strLst.add(stLine.nextToken());

				} // end while g[NA[v

				// 񂪎擾łȂꍇA
				if(strLst.size() == 0){
					// ReBj[
					continue;
				}

				//
				// e擾
				//

				// _̏ꍇA
				if(strLst.get(0).equals("v")){

					// _擾
					Float floatX = Float.valueOf((String)strLst.get(1));
					Float floatY = Float.valueOf((String)strLst.get(2));
					Float floatZ = Float.valueOf((String)strLst.get(3));

					// _ꗗɒǉ
					pointLst.add(floatX);
					pointLst.add(-floatY);
					pointLst.add(-floatZ);

				// eNX`̏ꍇA
				}else if(strLst.get(0).equals("vt")){

					// eNX`擾
					Float floatU = Float.valueOf((String)strLst.get(1));
					Float floatV = -Float.valueOf((String)strLst.get(2));

					// eNX`ꗗɒǉ
					texLst.add(floatU);
					texLst.add(floatV);

				// @̏ꍇA
				}else if(strLst.get(0).equals("vn")){

					// @擾
					Float floatX = Float.valueOf((String)strLst.get(1));
					Float floatY = Float.valueOf((String)strLst.get(2));
					Float floatZ = Float.valueOf((String)strLst.get(3));

					// @ꗗɒǉ
					normalLst.add(floatX);
					normalLst.add(-floatY);
					normalLst.add(-floatZ);

				// ʗvf̏ꍇA
				}else if(strLst.get(0).equals("f")){

					// sg₷悤ɁAOԖڂ̗vf폜
					strLst.remove(0);

					// p`H
					int intPolygon = strLst.size();

					// Rp`݂ꍇA
					while(intPolygon >= 3){

						//
						// P_
						//
						String str1 = strLst.get(0);

						// P_ڏ񕪉
						int[] intFaces1 = getFaces(str1);

						// @񂠂̏ꍇA
						// iXbVQꍇj
						if(intFaces1.length > countFaces){
							// ʗvf
							countFaces = intFaces1.length;
						}

						// _
						int v1 = intFaces1[0];
						faceLst.add(v1);

						int vn1 = 0;

						// @
						if(countFaces == 3){
							vn1 = intFaces1[2];
							faceLst.add(vn1);
						}

						// eNX`
						int vt1 = intFaces1[1];
						faceLst.add(vt1);

						//
						// Q_
						//
						String str2 = strLst.get(1);

						// Q_ڏ񕪉
						int[] intFaces2 = getFaces(str2);

						// _
						int v2 = intFaces2[0];
						faceLst.add(v2);

						int vn2 = 0;

						// @
						if(countFaces == 3){
							vn2 = intFaces2[2];
							faceLst.add(vn2);
						}

						// eNX`
						int vt2 = intFaces2[1];
						faceLst.add(vt2);

						//
						// R_
						//
						String str3 = strLst.get(2);

						// R_ڏ񕪉
						int[] intFaces3 = getFaces(str3);

						// _
						int v3 = intFaces3[0];
						faceLst.add(v3);

						int vn3 = 0;

						// @
						if(countFaces == 3){
							vn3 = intFaces3[2];
							faceLst.add(vn3);
						}

						// eNX`
						int vt3 = intFaces3[1];
						faceLst.add(vt3);

						// Pp`
						intPolygon--;

						// PԖځiQ_ځj̗vf폜
						strLst.remove(1);

					} // end while Rp`݂ꍇ

				// }eȀꍇA
				}else if(strLst.get(0).equals("usemtl")){

					// }eAǉ^`FbN
					Object[] materials = ObjReader.addCheckMaterial(faceLst, mapMaterial, strMaterialName);

					// }eAԋpĂꍇA
					if(materials != null){

						// }eAꗗɒǉ
						materialLst.add(materials);

						// ʗvfꗗ𐶐ij
						// ̖ʗvfꗗ
						// iYȂ悤Ƀj
						// neŵɁAȏォEEEB
						// }eAŌ̂̂Kpꂽ悤ɌĂ܂B
						faceLst = new ArrayList<Integer>();

					}

					// }eA擾
					strMaterialName = strLst.get(1);

				// IuWFNg̏ꍇA
				}else if(strLst.get(0).equals("o")){

					// }eAǉ^`FbN
					Object[] materials = ObjReader.addCheckMaterial(faceLst, mapMaterial, strMaterialName);

					// }eAԋpĂꍇA
					if(materials != null){

						// }eAꗗɒǉ
						materialLst.add(materials);

						// ʗvfꗗ𐶐ij
						// ̖ʗvfꗗ
						// iYȂ悤Ƀj
						// neŵɁAȏォEEEB
						// }eAŌ̂̂Kpꂽ悤ɌĂ܂B
						faceLst = new ArrayList<Integer>();

					}

					// }eA
					// }eAUA
					strMaterialName = null;

					// IuWFNgǉ^`FbN
					Object[] objects = ObjReader.addObject(strObjectName, materialLst);

					// IuWFNgԋpĂꍇA
					if(materials != null){

						// IuWFNgꗗɒǉ
						objectsLst.add(objects);

					}

					// }eAꗗ
					// IuWFNguovςĂ̂ŁA}eAꗗ̏Kv
					materialLst = new ArrayList<Object[]>();

					// IuWFNgݒ
					strObjectName = strLst.get(1);

				// }eAQƂ̏ꍇA
				}else if(strLst.get(0).equals("mtllib")){

					// }eA[_[}eA}bv擾
					mapMaterial = MaterialReader.getMaterials(strDefaultPath + strLst.get(1));

				} // end if

			} // end while sA[v

			// }eAǉ^`FbN
			Object[] materials = ObjReader.addCheckMaterial(faceLst, mapMaterial, strMaterialName);

			// }eAԋpĂꍇA
			if(materials != null){

				// }eAꗗɒǉ
				materialLst.add(materials);

			}

			// IuWFNgǉ^`FbN
			Object[] objects = ObjReader.addObject(strObjectName, materialLst);

			// IuWFNgԋpĂꍇA
			if(materials != null){

				// IuWFNgꗗɒǉ
				objectsLst.add(objects);

			}

			// IuWFNgꗗiXvCg}bvjɒǉ
			ObjReader.mapObjects.put(strSpriteKey, objectsLst);

			// _ꗗiXvCg}bvjɒǉ
			ObjReader.mapPoints.put(strSpriteKey, getFloats(pointLst));

			// eNX`WꗗiXvCg}bvjɒǉ
			ObjReader.mapTexs.put(strSpriteKey, getFloats(texLst));

			// _@ꗗiXvCg}bvjɒǉ
			ObjReader.mapNormals.put(strSpriteKey, getFloats(normalLst));

			// fobOo
			outputDebugInfo(1, "END ObjReader.init. strFilePath:" + strFilePath);

			// ^[
			return;

		}catch(Exception ex){

			// sȑꍇA
			if(row > 0){
				// G[̂so
				System.out.println("Error! row = : " + row);
			}

			// ̂܂܃G[X[
			throw ex;

		}finally{

			try{
				// N[Y
				if(isr != null){
					isr.close();
				}
			}catch(Exception ex){
				ex.printStackTrace();
			}

		}

	} // end init

	/**
	 * IuWFNgǉ^`FbN
	 */
	private static Object[] addObject(String strObjectName, ArrayList<Object[]> materialLst){

		// }eAꗗ݂ꍇA
		if(materialLst.size() > 0){

			// ԋppIuWFNg쐬
			Object[] objObjects = new Object[2];

			// ԋppIuWFNgݒ
			objObjects[0] = strObjectName;
			objObjects[1] = materialLst;

			// ^[
			return objObjects;

		// }eAꗗ݂ȂꍇA
		}else{

			// nullŃ^[
			return null;

		}

	} // end addObject

	/**
	 * }eAǉ^`FbN
	 */
	private static Object[] addCheckMaterial(ArrayList<Integer> faceLst, HashMap<String, PhongMaterial> mapMaterial, String strMaterialName){

		// ʗvf݂ꍇA
		// bVr[ǉłꍇA
		if(faceLst.size() > 0){

			// }eA쐬
			Object[] materials = createMaterial(faceLst, mapMaterial, strMaterialName);

			// ^[
			return materials;

		// ʗvf݂ȂꍇA
		}else{

			// nullŃ^[
			return null;

		}

	} // end addCheckMaterial

	/**
	 * }eA쐬
	 */
	private static Object[] createMaterial(ArrayList<Integer> faceLst, HashMap<String, PhongMaterial> mapMaterial, String strMaterialName){

		// fobOo
		outputDebugInfo(2, "START createMaterial.");

		// ԋpp}eA쐬
		Object[] objMaterials = new Object[2];

		//
		// ʗvfꗗ
		//

		// int[]Ŏ擾
		int[] intFaces = getInts(faceLst);

		// fobOo
		outputDebugInfo(2, "intFacesF" + intFaces.length);

		//
		// }eA
		//

		// }eA
		PhongMaterial material = null;

		// }eAێĂꍇA
		if(strMaterialName != null){

			// }eA擾
			material = mapMaterial.get(strMaterialName);

			// fobOo
			outputDebugInfo(2, "}eAKp usemtlF" + strMaterialName);

		} // end if }eAێĂꍇ

		// ԋpp}eAݒ
		objMaterials[0] = intFaces;
		objMaterials[1] = material;

		// fobOo
		outputDebugInfo(2, "END createMaterial.");

		// ԋpp}eA^[
		return objMaterials;

	} // end createMaterial

	/**
	 * ʗvf擾
	 */
	private static int[] getFaces(String strFace){

		// CfbNX擾
		int index_vt = -1;
		int index_tn = -1;

		// CfbNX_|eNX`擾
		index_vt = strFace.indexOf("/");

		int v = -1;
		int vt = -1;
		int vn = -1;

		// _擾
		if(index_vt != -1){
			v = Integer.valueOf(strFace.substring(0, index_vt)) - 1;
		}else{
			v = Integer.valueOf(strFace) - 1;
		}

		// CfbNX_|eNX`擾łꍇA
		if(index_vt != -1){

			// CfbNXeNX`擾
			index_tn = strFace.indexOf("/", index_vt + 1);

			// eNX`擾
			if(index_vt + 1 == index_tn){
				vt = 0;
			}else if(index_tn != -1){
				vt = Integer.valueOf(strFace.substring(index_vt + 1, index_tn)) - 1;
			}else{
				vt = Integer.valueOf(strFace.substring(index_vt + 1)) - 1;
			}

			// CfbNXeNX`擾łꍇA
			if(index_tn != -1){

				// @擾
				if(index_tn + 1 == strFace.length()){
					vn = 0;
				}else{
					vn = Integer.valueOf(strFace.substring(index_tn + 1)) - 1;
				}

			}

		// CfbNX_|eNX`擾łȂꍇA
		}else{
			vt = 0;
		}

		// fobOo
		outputDebugInfo(3, "v :" + v + " / vt:" + vt + " / vn:" + vn);

		int[] intFaces = null;

		if(vn == -1){
			intFaces = new int[2];
			intFaces[0] = v;
			intFaces[1] = vt;
		}else{
			intFaces = new int[3];
			intFaces[0] = v;
			intFaces[1] = vt;
			intFaces[2] = vn;
		}

		return intFaces;

	} // end getFaces

	/**
	 * 3DIuWFNg
	 * <pre>
	 * {Iɂ́A\bh𗘗pĂB
	 * </pre>
	 * @param group o^O[viXvCgPʁjBO[viNX|IuWFNgjɁAIuWFNgzu܂B
	 * @return HashMap IuWFNguovPʂGroupIuWFNg
	 */
	public static HashMap<String, Group> create(Group group){

		// XvCg擾L[
		String strSpriteKey = group.getClass().getName();

		// ʃ\bhĂяo
		return create(group, strSpriteKey);

	} // end create

	/**
	 * 3DIuWFNg
	 * @param group o^O[viXvCgPʁjBO[vɁAIuWFNgzu܂B
	 * @param strSpriteKey XvCg擾L[
	 * @return HashMap IuWFNguovPʂGroupIuWFNg
	 */
	public static HashMap<String, Group> create(Group group, String strSpriteKey){

		// fobOo
		outputDebugInfo(1, "START ObjReader.create. " + group);

		// IuWFNgꗗiXvCgPʁj擾
		ArrayList<Object[]> objectsLst = ObjReader.mapObjects.get(strSpriteKey);

		// _ꗗiXvCgPʁj擾
		float[] floatPoints = ObjReader.mapPoints.get(strSpriteKey);

		// eNX`WꗗiXvCgPʁj擾
		float[] floatTexs = ObjReader.mapTexs.get(strSpriteKey);

		// _@ꗗiXvCgPʁj擾
		float[] floatNormals = ObjReader.mapNormals.get(strSpriteKey);

		// IuWFNgꗗ̌擾
		int countObjectsLst = objectsLst.size();

		// fobOo
		outputDebugInfo(2, "XvCgf[^擾njH " + ((countObjectsLst > 0)?"njI": "mfI"));

		// O[v}bviIuWFNgPʁj𐶐
		HashMap<String, Group> mapGroup = new HashMap<String, Group>(countObjectsLst);

		// IuWFNgꗗ̌A[v
		for(int i = 0; i < countObjectsLst; i++){

			// IuWFNg擾
			Object[] objects = objectsLst.get(i);

			// IuWFNg擾
			String strObjectName = (String)objects[0];

			// O[viIuWFNgPʁj𐶐
			Group groupObject = new Group();

			// O[viXvCgPʁjɒǉ
			group.getChildren().add(groupObject);

			// O[v}bviIuWFNgPʁjɒǉ
			mapGroup.put(strObjectName, groupObject);

			// }eAꗗ擾
			Object o = objects[1];
			@SuppressWarnings("unchecked")
			ArrayList<Object[]> materialLst = (ArrayList<Object[]>)o;

			// }eAꗗ̌擾
			int countMaterialLst = materialLst.size();

			// fobOo
			outputDebugInfo(2, "}eAꗗ擾njH " + ((countMaterialLst > 0)?"njI": "mfI"));

			// }eAꗗ̌A[v
			for(int j = 0; j < countMaterialLst; j++){

				// }eA擾
				Object[] objMaterials = (Object[])materialLst.get(j);

				// ʗvfꗗ擾
				int[] intFaces = (int[])objMaterials[0];

				// }eA擾
				PhongMaterial material = (PhongMaterial)objMaterials[1];

				// bVr[쐬
				MeshView meshView = new MeshView();

				// bV쐬
				TriangleMesh mesh = new TriangleMesh();

				//
				// ebNX^_@ꗗݒ
				//

				// _@݂ꍇA
				if(floatNormals != null && floatNormals.length > 0){

					// ebNX̓m[}
					mesh.setVertexFormat(VertexFormat.POINT_NORMAL_TEXCOORD);

					// _@ꗗݒ
					mesh.getNormals().addAll(floatNormals);

				// LȊȌꍇA
				}else{

					// ebNX̓m[}ł͂Ȃ
					mesh.setVertexFormat(VertexFormat.POINT_TEXCOORD);

					// ʂ\悤ɂ܂B
					// JavaFXł́Avɓ_ꍇɁA\ƔfĂB
					// objt@C@Ȃꍇłv肪\ɂȂ悤A
					// ʂƂA\悤ɂ܂B
					meshView.setCullFace(CullFace.NONE);

				}

				//
				// _Wꗗ
				//

				// _Wꗗݒ
				mesh.getPoints().addAll(floatPoints);

				//
				// eNX`Wꗗ
				//

				// eNX`ݒ肳ꂽꍇA
				if(floatTexs != null && floatTexs.length > 0){

					// eNX`ꗗݒ
					mesh.getTexCoords().addAll(floatTexs);

				// eNX`ݒ肳ȂꍇA
				}else{

					// eNX`̃_~[ݒ
					mesh.getTexCoords().addAll(TEXCOORDS_DUMMY);

				}

				//
				// ʗvfꗗ
				//

				// ʗvfꗗݒ
				mesh.getFaces().addAll(intFaces);

				//
				// bVr[o^
				//

				// bVo^
				meshView.setMesh(mesh);

				// }eA擾łꍇA
				if(material != null){

					// }eAo^
					meshView.setMaterial(copyMaterial(material));

					// fobOo
					outputDebugInfo(2, "}eAo^ " + material);

				}

				// O[viIuWFNgPʁjɃbVr[ǉ
				groupObject.getChildren().add(meshView);

			} // end for }eAꗗ̌A[v

		} // end for IuWFNgꗗ̌A[v

		// fobOo
		outputDebugInfo(1, "END ObjReader.create. " + group);

		// O[v}bviIuWFNgPʁj^[
		return mapGroup;

	} // end create

	/**
	 * }eARs[
	 */
	private static PhongMaterial copyMaterial(PhongMaterial material){

		// }eA𐶐
		PhongMaterial materialWk = new PhongMaterial();

		// eRs[
		materialWk.setBumpMap(material.getBumpMap());
		materialWk.setDiffuseColor(material.getDiffuseColor());
		materialWk.setDiffuseMap(material.getDiffuseMap());
		materialWk.setSelfIlluminationMap(material.getSelfIlluminationMap());
		materialWk.setSpecularColor(material.getSpecularColor());
		materialWk.setSpecularMap(material.getSpecularMap());
		materialWk.setSpecularPower(material.getSpecularPower());

		// }eA^[
		return materialWk;

	} // end copyMaterial

	/**
	 * floatl擾
	 * @param floatLst ArrayList<Float>
	 * @return float[]
	 */
	private static float[] getFloats(ArrayList<Float> floatLst){

		// ꗗ̌擾
		int countFloatLst = floatLst.size();

		// ꗗ̗̌vfŐ
		float[] floats = new float[countFloatLst];

		// f[^̓]s
		for(int i = 0; i < countFloatLst; i++){

			floats[i] = floatLst.get(i).floatValue();

		}

		// ^[
		return floats;

	} // end getFloats

	/**
	 * intl擾
	 * @param floatLst ArrayList<Integer>
	 * @return int[]
	 */
	private static int[] getInts(ArrayList<Integer> intLst){

		// ꗗ̌擾
		int countIntLst = intLst.size();

		// ꗗ̗̌vfŐ
		int[] ints = new int[countIntLst];

		// f[^̓]s
		for(int i = 0; i < countIntLst; i++){

			ints[i] = intLst.get(i).intValue();

		}

		// ^[
		return ints;

	} // end getInts

	/**
	 * fobOo
	 * <pre>
	 * fobOx`FbNAR\[ɏo͂܂B
	 * </pre>
	 * @param strDebugInfo fobO
	 */
	private static void outputDebugInfo(int lvlDebug, String strDebugInfo){

		if(lvlDebug <= ObjReader.lvlDebug){

			System.out.println(strDebugInfo);

		}

	} // end outputDebugInfo

}
