import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Cylinder;
import javafx.scene.transform.Rotate;

/**
 * S̃[U[i[U[Qj
 */
public class PRSpriteGroupLaserTeki2 extends PRSpriteGroup {

	/** GXvCg */
	private		Group				sprite			= null;

	/**  */
	private		int					time			= 0;

	/** x */
	public		double				mx				= 0;
	public		double				my				= 0;
	public		double				mz				= 0;

	/** px */
	public		double				angleZ			= 0.0;
	public		double				angleX			= 0.0;

	/**
	 * 
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spritePrusher vC[
	 */
	public PRSpriteGroupLaserTeki2(PRApplication application, Group sprite) {

		super(application);

		// GXvCgێ
		this.sprite = sprite;

		// W
		double x = sprite.getTranslateX();
		double y = sprite.getTranslateY();
		double z = sprite.getTranslateZ();

		// xݒ
		this.mx = (application.getPRSpritePrusher().getTranslateX() - x) / 20;
		this.my = (application.getPRSpritePrusher().getTranslateY() - y) / 20;
		this.mz = (application.getPRSpritePrusher().getTranslateZ() - z) / 20;

		// pxێ
		this.angleZ = 270 - sprite.getRotate();
		double radX = Math.atan2(my, mz);
		this.angleX = radX * 180 / Math.PI;

		// [U[𐶐
		PRSpriteLaserTeki2 spriteLaserTeki2 = new PRSpriteLaserTeki2(application, sprite, this, 60);

		// XvCgǉ
		application.addNode(spriteLaserTeki2);

		// C`[WX^[g
		application.startWaveChargeBattleShip();

	} // end PRSpriteGroupLaserTeki2

	/**
	 * s
	 */
	public void run(){

		// Ԑݒ
		time++;

		// Pb܂
		if(time < 60){

			// Ȃ

		// Pb
		}else if(time == 60){

			// C䔭ˉX^[g
			application.startWaveFireBattleShip();

		// 1.5b
		}else if(time < 90){

			// [U[𐶐
			PRSpriteLaserTeki2 spriteLaserTeki2 = new PRSpriteLaserTeki2(application, sprite, this, 0);

			// XvCgǉ
			application.addNode(spriteLaserTeki2);

		// 1.5b
		}else if(time == 90){

			// XvCgO[v
			application.removeSpriteGroup(this);

		} // end if 

	} // end run

}
