import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Cylinder;
import javafx.scene.transform.Rotate;

/**
 * S̃[U[i[U[Qj
 */
public class PRSpriteLaserTeki2 extends PRSpriteTamaTeki0 {

	/** [U[̐F */
	private static final Color[]	COLOR_LASER		= new Color[]{
		Color.color(1.0, 0.8, 0.1, 0.8),
		Color.color(1.0, 0.6, 0.1, 0.6),
		Color.color(1.0, 0.4, 0.1, 0.4)
	};

	/** GXvCg */
	private		Group				sprite			= null;

	/** V_[ */
	private		Cylinder			cylinder		= null;

	/** }eA */
	private		PhongMaterial		materail		= null;

	/**  */
	private		int					time			= 0;

	/** x */
	private		double				mx				= 0;
	private		double				my				= 0;
	private		double				mz				= 0;

	/**
	 * 
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spritePrusher vC[
	 */
	public PRSpriteLaserTeki2(PRApplication application, Group sprite, PRSpriteGroupLaserTeki2 spriteGroup, int time) {

		super(application);

		// GXvCgێ
		this.sprite = sprite;

		// Ԃێ
		this.time = time;

		// V_[𐶐
		cylinder = new Cylinder(0.25, 4.5, 12);

		// ]i90xXj
		cylinder.getTransforms().add(new Rotate(90, Rotate.X_AXIS));

		// V_[ǉ
		this.getChildren().add(cylinder);

		// W
		double x = sprite.getTranslateX();
		double y = sprite.getTranslateY();
		double z = sprite.getTranslateZ();

		// }eA𐶐
		materail = new PhongMaterial();

		// }eAݒ
		cylinder.setMaterial(materail);

		// ʐFݒ
		materail.setSpecularPower(1.0);

		// eݒ
		application.addShadow(this, 0.5);

		// xݒ
		this.mx = spriteGroup.mx;
		this.my = spriteGroup.my;
		this.mz = spriteGroup.mz;

		// ]iC䕪AXj
		cylinder.getTransforms().add(new Rotate(spriteGroup.angleZ, Rotate.Z_AXIS));
		cylinder.getTransforms().add(new Rotate(spriteGroup.angleX, Rotate.X_AXIS));

		// ړ
		x = x + mx;
		y = y + my;
		z = z + mz;

		// ʒuݒ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// C`[WX^[g
		application.startWaveChargeBattleShip();

	} // end PRSpriteLaserTeki2

	/**
	 * s
	 */
	public void run(){

		// Ԑݒ
		time--;

		// ʒu擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// ԂOɂȂ܂
		if(time > 0){

			// Cɍ킹Ĉړ
			x = sprite.getTranslateX();
			y = sprite.getTranslateY();
			z = sprite.getTranslateZ();

		// LȊȌꍇA
		}else{

			// ړ
			x = x + mx;
			y = y + my;
			z = z + mz;

		} // end if 

		// ʒuݒ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// ʂ̊OɂłꍇA
		if(z < 0){
			// 폜
			application.removeNode(this);
		}

		// e̐F̐ݒ
		if(time % 3 == 0){
			int indexColor = (int)(Math.random() * 3);
			materail.setDiffuseColor(COLOR_LASER[indexColor]);
			materail.setSpecularColor(COLOR_LASER[indexColor]);
		}

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 蔻͈Z
	 */
//	@Override
//	public double getHaniZ() {
//		return 2.0;
//	}

}
