import java.util.HashMap;

import javafx.collections.ObservableList;
import javafx.geometry.BoundingBox;
import javafx.geometry.Bounds;
import javafx.geometry.Point3D;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.input.KeyCode;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.transform.Rotate;
import javafx.scene.transform.Translate;

/**
 * vC[
 */
public class PRSpriteTitlePrusher extends PRSprite {

	/** Er */
	private		Group				groupArmRight		= null;

	/** t@CA[ */
	private		Group				groupFire			= null;

	/** r */
	private		Group				groupArmLeft		= null;

	/** E */
	private		Group				groupLegRight		= null;

	/**  */
	private		Group				groupLegLeft		= null;

	/**  */
	private		int					time				= 0;

	/** r̊px */
	private		int					angleArmLeft		= 0;

	/**
	 * 
	 */
	public static void init() {

		// PRUSHER̂܂ܗp邽߁Ał͐ݒ肵ȂB

	} // end init

	/**
	 * RXgN^
	 */
	public PRSpriteTitlePrusher(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			HashMap<String, Group> map = ObjReader.create(this, Class.forName("PRSpritePrusher").getName());

			// ep[cێ
			groupArmRight = map.get("Arm_Right");
			groupFire = map.get("Fire");
			groupArmLeft = map.get("Arm_Left");
			groupLegRight = map.get("Leg_Right_Leg");
			groupLegLeft = map.get("Leg_Left_Leg");

			// ]
			groupArmLeft.getTransforms().add(new Rotate(180, Rotate.X_AXIS));

			// S_ݒ
			groupArmRight.getTransforms().add(new Translate(0.0, 0.11, 0.0));
			groupFire.getTransforms().add(new Translate(0.0, 0.10, 0.0));
			groupArmLeft.getTransforms().add(new Translate(0.10, 0.11, 0.0));
			groupLegRight.getTransforms().add(new Translate(0.0, -0.04, 0.04));
			groupLegLeft.getTransforms().add(new Translate(0.0, -0.04, 0.04));

			// ړ
			groupArmRight.setTranslateX(groupArmRight.getTranslateX() - 0.042);
			groupFire.setTranslateX(groupFire.getTranslateX() - 0.042);
			groupArmLeft.setTranslateX(groupArmLeft.getTranslateX() - 0.032);
			groupLegRight.setTranslateX(groupLegRight.getTranslateX() - 0.21);
			groupLegLeft.setTranslateX(groupLegLeft.getTranslateX() + 0.21);

			groupArmRight.setTranslateY(groupArmRight.getTranslateY() - 0.112);
			groupFire.setTranslateY(groupFire.getTranslateY() - 0.112);
			groupArmLeft.setTranslateY(groupArmLeft.getTranslateY() - 0.088);
			groupLegRight.setTranslateY(groupLegRight.getTranslateY() + 0.04);
			groupLegLeft.setTranslateY(groupLegLeft.getTranslateY() + 0.04);

			groupLegRight.setTranslateZ(groupLegRight.getTranslateZ() - 0.04);
			groupLegLeft.setTranslateZ(groupLegLeft.getTranslateZ() - 0.04);

			// ]ݒ
			super.setRotationAxis(Rotate.Y_AXIS);
			groupArmLeft.setRotationAxis(Rotate.Z_AXIS);
			groupLegRight.setRotationAxis(Rotate.X_AXIS);
			groupLegLeft.setRotationAxis(Rotate.X_AXIS);

			// ]
			super.setRotate(210);
			groupLegRight.setRotate(60);
			groupLegLeft.setRotate(60);

			// ʒuݒ
			this.setTranslateX(0.6);
			this.setTranslateY(-0.9);
			this.setTranslateZ(5.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteTitlePrusher

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		time++;

		// px̌vZ
		time = (time >= 90)?0: time;
		if(time < 45){
			angleArmLeft--;
		}else{
			angleArmLeft++;
		}

		// r̊px 
		groupArmLeft.setRotate(angleArmLeft);

	} // end run

}
