import java.util.HashMap;

import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.scene.Group;
import javafx.geometry.Bounds;
import javafx.scene.transform.Translate;
import javafx.scene.transform.Rotate;
import javafx.geometry.Point3D;

/**
 * ne
 * <pre>
 * ́An{e疽Ă܂B
 * gȂAn{eȂ̂ŁB
 * </pre>
 */
public class PRSpriteHarite extends PRSpriteT {

	/** ˈʒu| */
	private static Point3D		POS_L					= new Point3D(-4.5, 0.0, 1.0);
	/** ˈʒu|E */
	private static Point3D		POS_R					= new Point3D( 4.5, 0.0, 1.0);

	/** tF[Y */
	private		int				phase					= 0;

	/**  */
	private		int				time					= 0;

	/** p[c */
	private		Group			groupHatch				= null;
	private		Group			groupBatteryL			= null;
	private		Group			groupBatteryR			= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteHarite.class, "3d/Harite.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param stage Xe[W
	 */
	public PRSpriteHarite(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			HashMap<String, Group> map = ObjReader.create(this);

			// p[cێ
			groupHatch = map.get("Hatch");
			groupBatteryL = map.get("BatteryL");
			groupBatteryR = map.get("BatteryR");

			// nb`ғʒuړ
			// ]ɍ킹Ĉړ
			groupHatch.getTransforms().add(new Translate(0.0, -0.8, -0.1 - 0.5));
			// ̈ʒuֈړ
			groupHatch.setTranslateZ(0.1 + 0.5);
			groupHatch.setTranslateY(0.8);

			// nb`̉]ݒ
			groupHatch.setRotationAxis(Rotate.X_AXIS);

			// ʒuݒ
			super.setTranslateX(0.0);
			super.setTranslateY(-6.0);
			super.setTranslateZ(-10.0);

			// xݒ
			mz = 0.5;

			// eݒ
			application.addShadow(this, 6.0);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteHarite

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		time++;

		// W擾
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// tF[YO
		if(phase == 0){

			//
			// Z
			//

			// WZ
			z = z + mz;

			// ~ʒuA
			if(z > 50){

				// ԏ
				time = 0;

				// tF[YP
				phase = 1;

			}

			// ړ
			super.setTranslateZ(z);

		// tF[YP
		}else if(phase == 1){

			// 0.5b
			if(time == 60){

				// ԏ
				time = 0;

				// tF[YQ
				phase = 2;

			}

		// tF[YQ
		}else if(phase == 2){

			// nb`J
			groupHatch.setRotate(time / 2);

			// 2.0b
			if(time == 120){

				// ԏ
				time = 0;

				// tF[YR
				phase = 3;

			}

		// tF[YR
		}else if(phase == 3){

			// 1.0b
			if(time < 60){

				// Ȃ

			// 1.0b
			}else{

				// ԏ
				time = 0;

				// tF[YS
				phase = 4;

			}

		// tF[YS
		}else if(phase == 4){

			// }l{XO[v𐶐
			PRSpriteGroupManel spriteGroup = new PRSpriteGroupManel(application, "{XP", this);

			// AvP[VɃXvCgO[vǉ
			application.addSpriteGroup(spriteGroup);

			// ԏ
			time = 0;

			// tF[YT
			phase = 5;

		// tF[YT
		}else if(phase == 5){

			// 2.0b
			if(time < 120){

				// Ȃ

			// 3.0b
			}else if(time < 180){

				// 0.2b
				if(time % 12 == 0){

					// G̒e𐶐
					PRSpriteTamaTeki1 spriteTamaTekiL = new PRSpriteTamaTeki1(application, this, POS_L, 0.8);
					// G̒eǉ
					application.addNode(spriteTamaTekiL);

					// G̒e𐶐
					PRSpriteTamaTeki1 spriteTamaTekiR = new PRSpriteTamaTeki1(application, this, POS_R, 0.8);
					// G̒eǉ
					application.addNode(spriteTamaTekiR);

					// G̒eX^[g
					application.startWaveTamaTeki();

				}

			// 3.0b
			}else{

				// ԏ
				time = 0;

			} // end if 

		// tF[YU
		}else if(phase == 6){

			// WZ
			y = y + my;
			z = z + mz;

			// ʂ̊OɂłꍇA
			if(z > 300){
				// 폜
				super.remove();
			}

			// ړ
			super.setTranslateY(y);
			super.setTranslateZ(z);

		} // end if tF[Y

	} // end run

	/**
	 * ދp
	 */
	public void retreat(){

		// ԏ
		time = 0;

		// xݒ
		my = -0.1;
		mz = 1.0;

		// tF[YU
		phase = 6;

	} // end retreat

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.4;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.8;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.2;
	}

}
