import javafx.scene.transform.Rotate;

/**
 * [hZNg
 */
public class PRSpriteMode extends PRSprite {

	/** [h */
	private		int				mode			= 0;

	/** XX */
	private		Rotate			rotateX			= null;
	private		int				angleX			= 0;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteMode.class, "3d/Ship.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 */
	public PRSpriteMode(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// Wݒ
			super.setTranslateX(-0.4);
			super.setTranslateY(-0.38);
			super.setTranslateZ(6);

			// IuWFNg
			ObjReader.create(this);

			// k
			super.setScaleX(0.02);
			super.setScaleY(0.02);
			super.setScaleZ(0.02);

			// ]
			this.getTransforms().add(new Rotate(180, Rotate.Y_AXIS));

			// Rotate𐶐
			rotateX = new Rotate(angleX, Rotate.X_AXIS);

			// ]pɓo^
			this.getTransforms().add(rotateX);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteMode

	/**
	 * s
	 */
	@Override
	public void run(){

		// pxvZ
		angleX = angleX + ((mode == 0)?-4: 4);

		angleX = (angleX > 360)?angleX - 360: angleX;
		angleX = (angleX < 0)?angleX + 360: angleX;

		// pxݒ
		rotateX.setAngle(angleX);

	} // end run

	/**
	 * [hݒ
	 */
	public void setMode(int mode){

		// [hێ
		this.mode = mode;

		// ʒuݒ
		super.setTranslateY(-0.38 + mode * 0.16);

	} // end run

}
