import javafx.geometry.Point3D;
import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.geometry.Bounds;

/**
 * Yoor[
 */
public class PRSpriteZBB extends PRSpriteT {

	/** ]x */
	private		double			s			= Math.random() * 4 + 2;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteZBB.class, "3d/Zbb.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param stage Xe[W
	 */
	public PRSpriteZBB(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// Xݒ
			double x = Math.random() * 20.0 - 10.0;

			// Xݒ
			super.setTranslateX(x);

			// Zݒ
			super.setTranslateZ(150);

			// IuWFNg
			ObjReader.create(this);

			// ]
			Point3D p = new Point3D(Math.random() - 0.5, Math.random() - 0.5, Math.random() - 0.5);

			// ]ݒ
			super.setRotationAxis(p);

			// g^k
			super.setScaleX(0.8);
			super.setScaleY(0.8);
			super.setScaleZ(0.8);

			// xݒ
			mz = -1.8;

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteZBB

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		double x = super.getTranslateX();
		x = x + mx;

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0){
			// 폜
			super.remove();
		}

		// ړ
		super.setTranslateZ(z);

		// ]
		super.setRotate(getRotate() + this.s);

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
